
//Title:       RFTP FrameFM
//Version:     1.0
//Copyright:   1999
//Author:      Mary Grzywa
//Company:     Illinois State University Graduate Project
//Description: Resumable File Transfer Protocol
package rftp;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.io.*;
import javax.swing.filechooser.*;
import java.util.*;
import javax.swing.event.*;

public class FrameFM extends JFrame {
  JMenuBar menuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  JMenu menuHelp = new JMenu();
  JMenuItem menuHelpAbout = new JMenuItem();
  JToolBar toolBar = new JToolBar();
  JButton jButton3 = new JButton();
  ImageIcon image1;
  ImageIcon image2;
  ImageIcon image3;
  JLabel statusBar = new JLabel();
  JMenuItem jMenuItemConnect = new JMenuItem();
  JMenuItem jMenuItemLogin = new JMenuItem();
  JMenuItem jMenuItemDisconnect = new JMenuItem();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton jButton4 = new JButton();
  JFileChooser jFileChooser1 = new JFileChooser();
  JLabel StatusLabel = new JLabel();
  String string1;
  File file1;
  JButton jButton5 = new JButton();
  JPanel RemotejPanel = new JPanel();
  JScrollPane RemotejScrollPane = new JScrollPane();
  JList RemotejList = new JList();
  DefaultListModel RemoteListModel = new DefaultListModel();
  JLabel RemoteDirjLabel = new JLabel();
  JTextField RemoteDirTextField = new JTextField();
  JButton jButtonLogin = new JButton();
  JButton jButtonDisconnect = new JButton();
  JButton jButtonConnect = new JButton();
  JButton jButtonRetreive = new JButton();
  JButton jButtonResRet = new JButton();
  JButton jButton6 = new JButton();
  JButton jButton7 = new JButton();
  JButton jButton8 = new JButton();
  JLabel RemoteFileLabel = new JLabel();
  JTextField RemoteFileTextField = new JTextField();
  JButton RemoteCDupButton = new JButton();
  long connectTimeInSeconds;
  RftpClient client = null;
  private static java.util.Vector FMVec = new java.util.Vector(20,20);
  ConnectDialog aConnectDialog = null;
  LoginDialog aLoginDialog = null;
  NewDirDialog aNewDirDialog = null;
  TransferFileD aTransferDialog = null;
  RftpHelp aRftpHelp = null;
  JLabel RemoteDetailLabelSize = new JLabel();
  JLabel RemoteDetailSize = new JLabel();
  JLabel RemoteDetailLabelMod = new JLabel();
  JLabel RemoteDetailMod = new JLabel();
  JButton RemoteNewDirButton = new JButton();
  ShowHistory aHistory = null;
  JButton jButtonShowHistory = new JButton();
  StringBuffer transferType = new StringBuffer("");
  JLabel jLabelServerName = new JLabel();
  StringBuffer transferCmd = new StringBuffer("");
  File localFileBeingTransferred = new File(".");  // initialized value not to be used
  StringBuffer remoteFileBeingTransferred = new StringBuffer("");
  int lengthToTransfer = 0;
  JLabel ProgressLabel = new JLabel();
  JButton refreshButton = new JButton();

  //Construct the frame
  public FrameFM() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
 //   image1 = new ImageIcon(rftp.FrameFM.class.getResource("openFile.gif"));
 //   image2 = new ImageIcon(rftp.FrameFM.class.getResource("closeFile.gif"));
  //  image3 = new ImageIcon(rftp.FrameFM.class.getResource("help.gif"));
    image1 = new ImageIcon("images/openFile.gif");
    image2 = new ImageIcon("images/closeFile.gif");
    image3 = new ImageIcon("images/help.gif");
    string1 = "";
    file1 = jFileChooser1.getCurrentDirectory();
    this.getContentPane().setLayout(borderLayout1);
    this.getContentPane().setBackground(new java.awt.Color(250, 250, 250));
    this.setSize(new Dimension(982, 528));
    this.setTitle("Resumable File Transfer Protocol");
    this.addWindowListener(new java.awt.event.WindowAdapter() {

      public void windowOpened(WindowEvent e) {
        this_windowOpened(e);
      }
    });
    statusBar.setText(" ");
    menuFile.setText("File");
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        fileExit_actionPerformed(e);
      }
    });
    menuHelp.setText("Help");
    menuHelpAbout.setText("About");
    menuHelpAbout.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        helpAbout_actionPerformed(e);
      }
    });
    jButton3.setIcon(image3);
    jButton3.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton3_actionPerformed(e);
      }
    });
    jButton3.setMaximumSize(new Dimension(40, 34));
    jButton3.setMinimumSize(new Dimension(40, 34));
    jButton3.setPreferredSize(new Dimension(40, 34));
    jButton3.setToolTipText("Help");
    jMenuItemConnect.setText("Connect");
    jMenuItemConnect.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jMenuItemConnect_actionPerformed(e);
      }
    });
    jMenuItemLogin.setText("Login");
    jMenuItemDisconnect.setText("Disconnect");
    jMenuItemDisconnect.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jMenuItemDisconnect_actionPerformed(e);
      }
    });
    jButton4.setFont(new java.awt.Font("Serif", 3, 18));
    jButton4.setForeground(new java.awt.Color(100, 50, 200));
    jButton4.setText("Local File System");
    jButton4.setBounds(new Rectangle(5, 47, 474, 26));
    jPanel1.setLayout(null);
    jFileChooser1.setBorder(BorderFactory.createLoweredBevelBorder());
    jFileChooser1.setName(string1);
    jFileChooser1.setApproveButtonText("Select");
    jFileChooser1.setFileFilter(null);
    jFileChooser1.setBounds(new Rectangle(1, 73, 478, 329));
    StatusLabel.setFont(new java.awt.Font("Dialog", 0, 14));
    StatusLabel.setForeground(new java.awt.Color(90, 40, 183));
    StatusLabel.setBounds(new Rectangle(6, 10, 250, 24));
    jButton5.setFont(new java.awt.Font("Serif", 3, 18));
    jButton5.setForeground(new java.awt.Color(100, 50, 200));
    jButton5.setText("Remote File System");
    jButton5.setBounds(new Rectangle(529, 47, 431, 27));
    jButton5.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton5_actionPerformed(e);
      }
    });
    RemotejPanel.setBorder(BorderFactory.createLoweredBevelBorder());
    RemotejPanel.setBounds(new Rectangle(529, 74, 435, 328));
    RemotejPanel.setLayout(null);
    RemotejScrollPane.setBounds(new Rectangle(4, 44, 420, 187));
    RemoteDirjLabel.setHorizontalAlignment(SwingConstants.RIGHT);
    RemoteDirjLabel.setText("Look in:");
    RemoteDirjLabel.setBounds(new Rectangle(7, 15, 52, 17));
    RemoteDirTextField.setBounds(new Rectangle(64, 12, 228, 21));
    RemoteDirTextField.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        RemoteDirTextField_actionPerformed(e);
      }
    });
    jButtonLogin.setMaximumSize(new Dimension(40, 34));
    jButtonLogin.setMinimumSize(new Dimension(40, 34));
    jButtonLogin.setPreferredSize(new Dimension(40, 34));
    jButtonLogin.setToolTipText("Login");
    jButtonLogin.setActionCommand("jButtonLogin");
    jButtonLogin.setHorizontalTextPosition(SwingConstants.CENTER);
    jButtonLogin.setIcon(new ImageIcon("images/connectlogin.gif"));
    jButtonLogin.addActionListener(new FrameFM_jButtonLogin_actionAdapter(this));
    jButtonDisconnect.setMaximumSize(new Dimension(40, 34));
    jButtonDisconnect.setMinimumSize(new Dimension(40, 34));
    jButtonDisconnect.setPreferredSize(new Dimension(40, 34));
    jButtonDisconnect.setToolTipText("Disconnect");
    jButtonDisconnect.setActionCommand("jButtonDisconnect");
    jButtonDisconnect.setHorizontalTextPosition(SwingConstants.CENTER);
    jButtonDisconnect.setIcon(new ImageIcon("images/disconnect.gif"));
    jButtonDisconnect.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButtonDisconnect_actionPerformed(e);
      }
    });
    jButtonConnect.setMaximumSize(new Dimension(40, 34));
    jButtonConnect.setMinimumSize(new Dimension(40, 34));
    jButtonConnect.setPreferredSize(new Dimension(40, 34));
    jButtonConnect.setToolTipText("Connect");
    jButtonConnect.setActionCommand("jButtonConnect");
    jButtonConnect.setHorizontalTextPosition(SwingConstants.CENTER);
    jButtonConnect.setIcon(new ImageIcon("images/connectmake.gif"));
    jButtonConnect.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButtonConnect_actionPerformed(e);
      }
    });
    jButtonRetreive.setMaximumSize(new Dimension(34, 34));
    jButtonRetreive.setMinimumSize(new Dimension(34, 34));
    jButtonRetreive.setPreferredSize(new Dimension(34, 34));
    jButtonRetreive.setToolTipText("Retrieve File");
    jButtonRetreive.setActionCommand("jButtonRetrieve");
    jButtonRetreive.setHorizontalTextPosition(SwingConstants.CENTER);
    jButtonRetreive.setIcon(new ImageIcon("images/retr.GIF"));
    jButtonRetreive.setBounds(new Rectangle(485, 95, 39, 41));
    jButtonRetreive.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButtonRetreive_actionPerformed(e);
      }
    });
    jButtonResRet.setMaximumSize(new Dimension(34, 34));
    jButtonResRet.setMinimumSize(new Dimension(34, 34));
    jButtonResRet.setPreferredSize(new Dimension(34, 34));
    jButtonResRet.setToolTipText("Resume Retrieval");
    jButtonResRet.setActionCommand("jButtonResRet");
    jButtonResRet.setHorizontalTextPosition(SwingConstants.CENTER);
    jButtonResRet.setIcon(new ImageIcon("images/resrtr.GIF"));
    jButtonResRet.setBounds(new Rectangle(485, 140, 39, 40));
    jButtonResRet.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButtonResRet_actionPerformed(e);
      }
    });
    jButton6.setMaximumSize(new Dimension(34, 34));
    jButton6.setMinimumSize(new Dimension(34, 34));
    jButton6.setPreferredSize(new Dimension(34, 34));
    jButton6.setToolTipText("Abort transfer");
    jButton6.setHorizontalTextPosition(SwingConstants.CENTER);
    jButton6.setIcon(new ImageIcon("images/stop1.gif"));
    jButton6.setBounds(new Rectangle(484, 185, 40, 38));
    jButton6.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton6_actionPerformed(e);
      }
    });
    jButton7.setMaximumSize(new Dimension(34, 34));
    jButton7.setMinimumSize(new Dimension(34, 34));
    jButton7.setPreferredSize(new Dimension(34, 34));
    jButton7.setToolTipText("Store File");
    jButton7.setHorizontalTextPosition(SwingConstants.CENTER);
    jButton7.setIcon(new ImageIcon("images/store.GIF"));
    jButton7.setBounds(new Rectangle(485, 229, 39, 39));
    jButton7.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton7_actionPerformed(e);
      }
    });
    jButton8.setMaximumSize(new Dimension(34, 34));
    jButton8.setMinimumSize(new Dimension(34, 34));
    jButton8.setPreferredSize(new Dimension(34, 34));
    jButton8.setToolTipText("Resume Store");
    jButton8.setHorizontalTextPosition(SwingConstants.CENTER);
    jButton8.setIcon(new ImageIcon("images/resstor.GIF"));
    jButton8.setBounds(new Rectangle(483, 273, 41, 42));
    jButton8.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton8_actionPerformed(e);
      }
    });
    RemoteFileLabel.setHorizontalAlignment(SwingConstants.RIGHT);
    RemoteFileLabel.setText("File Name: ");
    RemoteFileLabel.setBounds(new Rectangle(9, 248, 73, 17));
    RemoteFileTextField.setBounds(new Rectangle(90, 248, 324, 21));
    RemoteCDupButton.setActionCommand("RemoteCDupButton");
    RemoteCDupButton.setHorizontalTextPosition(SwingConstants.CENTER);
    RemoteCDupButton.setIcon(new ImageIcon("images/cdUpSm.GIF"));
    RemoteCDupButton.setBounds(new Rectangle(308, 10, 24, 26));
    RemoteCDupButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        RemoteCDupButton_actionPerformed(e);
      }
    });
    RemotejList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {

      public void valueChanged(ListSelectionEvent e) {
        RemotejList_valueChanged(e);
      }
    });
    RemoteDetailLabelSize.setText("Size:    (bytes)");
    RemoteDetailLabelSize.setBounds(new Rectangle(94, 279, 98, 17));
    RemoteDetailSize.setBounds(new Rectangle(94, 298, 93, 17));
    RemoteDetailLabelMod.setText("Last Modified: ");
    RemoteDetailLabelMod.setBounds(new Rectangle(205, 280, 136, 17));
    RemoteDetailMod.setBounds(new Rectangle(204, 300, 220, 17));
    RemoteNewDirButton.setHorizontalTextPosition(SwingConstants.CENTER);
    RemoteNewDirButton.setIcon(new ImageIcon("images/cdNewSm.GIF"));
    RemoteNewDirButton.setBounds(new Rectangle(343, 10, 24, 27));
    RemoteNewDirButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        RemoteNewDirButton_actionPerformed(e);
      }
    });
    jButtonShowHistory.setMaximumSize(new Dimension(40, 34));
    jButtonShowHistory.setMinimumSize(new Dimension(40, 34));
    jButtonShowHistory.setPreferredSize(new Dimension(40, 34));
    jButtonShowHistory.setToolTipText("Show History");
    jButtonShowHistory.setIcon(new ImageIcon("images/hist.GIF"));
    jButtonShowHistory.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButtonShowHistory_actionPerformed(e);
      }
    });
    jLabelServerName.setFont(new java.awt.Font("Dialog", 0, 14));
    jLabelServerName.setForeground(new java.awt.Color(90, 40, 183));
    jLabelServerName.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabelServerName.setBounds(new Rectangle(744, 17, 213, 17));
    ProgressLabel.setFont(new java.awt.Font("Dialog", 0, 14));
    ProgressLabel.setForeground(new java.awt.Color(90, 40, 183));
    ProgressLabel.setBounds(new Rectangle(375, 11, 225, 17));
    refreshButton.setMaximumSize(new Dimension(49, 23));
    refreshButton.setMinimumSize(new Dimension(49, 23));
    refreshButton.setPreferredSize(new Dimension(49, 23));
    refreshButton.setIcon(new ImageIcon("images/refresh.GIF"));
    refreshButton.setBounds(new Rectangle(378, 10, 26, 27));
    refreshButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        refreshButton_actionPerformed(e);
      }
    });
    menuFile.add(jMenuItemConnect);
    menuFile.add(jMenuItemLogin);
    menuFile.add(jMenuItemDisconnect);
    menuFile.addSeparator();
    menuFile.add(menuFileExit);
    menuHelp.add(menuHelpAbout);
    menuBar1.add(menuFile);
    menuBar1.add(menuHelp);
    this.setJMenuBar(menuBar1);
    this.getContentPane().add(statusBar, BorderLayout.EAST);
    this.getContentPane().add(toolBar, BorderLayout.NORTH);
    toolBar.add(jButtonConnect, null);
    toolBar.add(jButtonLogin, null);
    toolBar.add(jButtonDisconnect, null);
    toolBar.add(jButtonShowHistory, null);
    toolBar.add(jButton3);
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jFileChooser1, null);
    jPanel1.add(jButton4, null);
    jPanel1.add(jButton8, null);
    jPanel1.add(jButton7, null);
    jPanel1.add(jButton6, null);
    jPanel1.add(jButtonResRet, null);
    jPanel1.add(jButtonRetreive, null);
    jPanel1.add(RemotejPanel, null);
    RemotejPanel.add(RemoteDirTextField, null);
    RemotejPanel.add(RemoteDirjLabel, null);
    RemotejPanel.add(RemoteCDupButton, null);
    RemotejPanel.add(RemotejScrollPane, null);
    RemotejScrollPane.getViewport().add(RemotejList, null);
    RemotejPanel.add(RemoteNewDirButton, null);
    RemotejPanel.add(RemoteDetailSize, null);
    RemotejPanel.add(RemoteDetailLabelMod, null);
    RemotejPanel.add(RemoteDetailLabelSize, null);
    RemotejPanel.add(RemoteFileTextField, null);
    RemotejPanel.add(RemoteFileLabel, null);
    RemotejPanel.add(RemoteDetailMod, null);
    RemotejPanel.add(refreshButton, null);
    jPanel1.add(jButton5, null);
    jPanel1.add(StatusLabel, null);
    jPanel1.add(jLabelServerName, null);
    jPanel1.add(ProgressLabel, null);
    RemotejList.setModel(RemoteListModel);
    setStatus("Not Connected");
  }

  //File | Exit action performed
  public void fileExit_actionPerformed(ActionEvent e) {
    jButtonDisconnect_actionPerformed(e);
    System.exit(0);
  }

  //Help | About action performed
  public void helpAbout_actionPerformed(ActionEvent e) {
    FrameFM_AboutBox dlg = new FrameFM_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }

  void jButton5_actionPerformed(ActionEvent e) {

  }

  void jButtonRetreive_actionPerformed(ActionEvent e) {
     setStatus("Transferring File");
     //System.out.println(jFileChooser1.getSelectedFile());
     setTransferType(new StringBuffer("Transfer from Remote to Local File"));
	   aTransferDialog = new TransferFileD();
	   //aTransferDialog.show();
     RunTransfer rt = new RunTransfer(aTransferDialog);
     Thread newTransferThread = new Thread(rt);
	   newTransferThread.start();
	   return;
  }

  void jButtonConnect_actionPerformed(ActionEvent e) {
     aConnectDialog = new ConnectDialog(new JFrame(), "Connect to RFTP Server");
	   aConnectDialog.show();
  }

  void this_windowOpened(WindowEvent e) {
    FMVec.addElement(this);
  }
   public static FrameFM getConnectDialogsFileMover(ConnectDialog c) {
  FrameFM d;
  for (int i = 0; i < FMVec.size(); i++) {
	  d = (FrameFM) FMVec.elementAt(i);
	  if (d.aConnectDialog.equals(c)) return(d);
  }
  throw new RuntimeException("Unknown FileMover");
}
 public static FrameFM getLoginDialogParent(LoginDialog c)  {
 FrameFM d;
  for (int i = 0; i < FMVec.size(); i++) {
	  d = (FrameFM) FMVec.elementAt(i);
	  if (d.aLoginDialog.equals(c)) return(d);
  }
  throw new RuntimeException("Unknown FileMover");
}
public static FrameFM getMakeDirParent(NewDirDialog c)  {
 FrameFM d;
  for (int i = 0; i < FMVec.size(); i++) {
	  d = (FrameFM) FMVec.elementAt(i);
	  if (d.aNewDirDialog.equals(c)) return(d);
  }
  throw new RuntimeException("Unknown FileMover");
}
  public static FrameFM getTransferDialogParent(TransferFileD c)  {
 FrameFM d;
  for (int i = 0; i < FMVec.size(); i++) {
	  d = (FrameFM) FMVec.elementAt(i);
	  if (d.aTransferDialog.equals(c)) return(d);
  }
  throw new RuntimeException("Unknown FileMover");
}

public void appendToHistory(String s) {
  if (aHistory == null)
          aHistory = new ShowHistory();
  aHistory.HistoryList.addElement(s);
	return;
}

public RftpClient getTheClient() {
	return getclient();
}
private RftpClient getclient() {
	if (client == null) {
		try {
			client = new rftp.RftpClient();

		} catch (java.lang.Throwable ivjExc) {		}
	};
	return client;
}

public String handleServerResponse(String fromServer) {
		// Display the command responses in the scrolling status area.
	// return the data attached without the command responses
	// command responses have the format nnn ***message from server***
	// the string orignially can have several concatenated command responses and data.
	StringBuffer s = new StringBuffer(fromServer);
	int startcmd;
	int endcmd;
	while (s.toString().indexOf(" ***") > 0)
	{  //System.out.println("HandleServerResponse: s:" + s.toString());
	   startcmd = s.toString().indexOf(" ***") - 3;
	   endcmd = s.toString().indexOf("***",startcmd + 7);
	   if (endcmd < 0) break;
	   appendToHistory(s.toString().substring(startcmd + 7,endcmd));
	   String a;  // the part before the substring (if any)
	   String b;  // the part after the substring (if any)
	   
	   if (startcmd == 0) a = new String("");
	     else a = s.toString().substring(0,startcmd - 1);
	   if (endcmd + 3 == s.toString().length()) b = new String("");
	     else b = s.toString().substring(endcmd +3, s.toString().length());
	   // System.out.println("HandleServerResponse: String a:" + a + " String b: " + b);
	   s.setLength(0);
	   s.append(a).append(b);
	 }
	
	return s.toString();

}
public String stripAwayNewlines(String s) {
	StringBuffer stripped = new StringBuffer("");
	 for (int i = 0;i < s.length();i++)
	 { 
	   if ((char) s.charAt(i) != '\n') stripped.append((char) s.charAt(i));
	 }
	 return stripped.toString();

}

public void displayRemoteDirectory(String rFiles) {
	String filelist = handleServerResponse(rFiles);
	RemoteListModel.removeAllElements();
	StringBuffer flist = new StringBuffer(filelist);
  if ((filelist.indexOf("null") > 0) && (flist.length() == 6) )  ; //don't add anything to list
	 else	for (int i = flist.toString().indexOf('\n'); i >= 0;i = flist.toString().indexOf('\n'))
	  {
	  RemoteListModel.addElement(flist.toString().substring(0,i));
	  String shortened = new String(flist.toString().substring(i+1,flist.length()));
	  flist.setLength(0);
	  flist.append(shortened);
	  }
}

public void setStatus(String s) {
	StatusLabel.setText(s);
  if (s.equals("Not Connected"))
	{
	  jButton6.setEnabled(false);
	  jButtonResRet.setEnabled(false);
  	jButtonRetreive.setEnabled(false);
	  jButton7.setEnabled(false);
	  jButton8.setEnabled(false);
	  menuFileExit.setEnabled(true);
	  jMenuItemConnect.setEnabled(true);
    jMenuItemDisconnect.setEnabled(false);
    jMenuItemLogin.setEnabled(false);
    jButtonConnect.setEnabled(true);
    jButtonDisconnect.setEnabled(false);
    jButtonLogin.setEnabled(false);
	}
	else if (s.equals("Connected"))
	{
    jMenuItemConnect.setEnabled(false);
    jMenuItemDisconnect.setEnabled(true);
    jMenuItemLogin.setEnabled(true);
    jButtonConnect.setEnabled(false);
    jButtonDisconnect.setEnabled(true);
    jButtonLogin.setEnabled(true);
	  StatusLabel.setText("Connected.  Please login.");
	}
	else if (s.equals("Ready"))
	{
	  jButton6.setEnabled(false);
	  jButtonResRet.setEnabled(true);
	  jButton8.setEnabled(true);
  	jButtonRetreive.setEnabled(true);
	  jButton7.setEnabled(true);
    jMenuItemLogin.setEnabled(false);
    jButtonLogin.setEnabled(false);
	}
	else if (s.equals("Transferring File"))
	{
	   jButton6.setEnabled(true);
	}
}

public String getStatus() {
	return StatusLabel.getText();
  }

public void setConnectTimeInSeconds(long newValue) {
	this.connectTimeInSeconds = newValue;
}

void jButtonLogin_actionPerformed(ActionEvent e) {
      aLoginDialog = new LoginDialog(new JFrame(), "Login to RFTP Server");
	   aLoginDialog.show();
  }



class FrameFM_jButtonLogin_actionAdapter implements java.awt.event.ActionListener {
  FrameFM adaptee;

  FrameFM_jButtonLogin_actionAdapter(FrameFM adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonLogin_actionPerformed(e);
  }
}

  void RemotejList_valueChanged(ListSelectionEvent e) {
 try {
  String currentDirectory = RemoteDirTextField.getText();
  String sepChar;
  if (currentDirectory.indexOf("\\") < 0) sepChar = "/"; else sepChar = "\\";
  String s = RemotejList.getSelectedValue().toString();
	if (s.indexOf("<dir>") < 0)      //its a file
	{
	     RemoteFileTextField.setText(s);
	     StringBuffer statcmd = new StringBuffer("STAT ");

       statcmd.append(RemoteDirTextField.getText());
       if (sepChar.equals("\\"))
         if ( currentDirectory.length()!= 3 )       //DOS drive C:\ is 3 chars
             statcmd.append(sepChar);
       if (sepChar.equals("/"))
       if ( currentDirectory.length() != 1)         //UNIX root drive / is 1 char
         statcmd.append(sepChar);
	     statcmd.append(s);
	     String statReply = getTheClient().performRequest(statcmd);
	     if (statReply.startsWith("2"))
	     {
		     int mod = statReply.indexOf("Last Modified:");
		     int siz = statReply.indexOf("Size: ");
		     if ((mod >= 0) && (siz >= 0))
		     {
			     mod = mod + 15;
			     String lastmod = new String(statReply.substring(mod,siz - 1));
			     siz = siz + 6;
			     String filesize = new String(statReply.substring(siz,statReply.length() - 3));
			     setDetailsVisible(true);
			     RemoteDetailMod.setText(lastmod);
	         RemoteDetailSize.setText(filesize);
           appendToHistory("Selected file: " + s + " Size: " + filesize + " Last Modified: " + lastmod);
		     }
	     }
	}
	else   //its a dir
	{ 
	   setDetailsVisible(false);
	   RemoteFileTextField.setText("");
	   StringBuffer newDirectory = new StringBuffer(currentDirectory);
     if (sepChar.equals("\\"))
      if ( currentDirectory.length()!= 3 )       //DOS drive C:\ is 3 chars
        newDirectory.append(sepChar);
     if (sepChar.equals("/"))
       if ( currentDirectory.length() != 1)         //UNIX root drive / is 1 char
         newDirectory.append(sepChar);
	   newDirectory.append(s.substring(6,s.length()));
	   //System.out.println("newDir: " + newDirectory.toString() + " substring: " + s.substring(6,s.length()) );
	   RemoteDirTextField.setText(newDirectory.toString());
	   StringBuffer cwdCmd = new StringBuffer("CWD ");
	   cwdCmd.append(newDirectory.toString());
	   String cwdReply = getTheClient().performRequest(cwdCmd);
     appendToHistory("Folder Change to " + newDirectory.toString());
	   String unusedString = handleServerResponse(cwdReply);
	   String listReply = getTheClient().performRequest(new StringBuffer("LIST"));
	  // System.out.println("***" + listReply + "***");
	   displayRemoteDirectory(listReply);
    } 

	} catch (NullPointerException eieieo) {}     //null pointer to selected value can be ignored
    catch (RuntimeException ioe) {System.out.println("runtimeexcept in directory select");}
	return;
}
 public void setDetailsVisible(boolean b) {
  if (b == true)
  {
  RemoteDetailLabelMod.setText("Last Modified:");
  RemoteDetailLabelSize.setText("Size:  (bytes)");
  }
  else
  {
   RemoteDetailLabelMod.setText("");
   RemoteDetailLabelSize.setText("");
   RemoteDetailMod.setText("");
   RemoteDetailSize.setText("");
  }
}

  void RemoteCDupButton_actionPerformed(ActionEvent e) {
  setDetailsVisible(false);
  appendToHistory("Folder Change: Moving up one level");
  try {
  String cdupReply =  getTheClient().performRequest(new StringBuffer("CDUP") );
	String cdupcdup  = handleServerResponse(cdupReply);
  if (cdupReply.indexOf("***") < 0)  {appendToHistory("Folder access denied ");}
  else {
	  String pwdReply = getTheClient().performRequest(new StringBuffer("PWD"));
    String cleaned = handleServerResponse(pwdReply);
    String strippedPwdReply = stripAwayNewlines(cleaned);
    RemoteDirTextField.setText(strippedPwdReply);
    RemoteFileTextField.setText("");
    String listReply = getTheClient().performRequest(new StringBuffer("LIST"));
    displayRemoteDirectory(listReply);
    appendToHistory("Folder change to " + strippedPwdReply);
  }
  } catch (NullPointerException npe) { }
  return;
}

  void RemoteDirTextField_actionPerformed(ActionEvent e) {
     StringBuffer cmd = new StringBuffer("CWD ");
     String requestedDir = RemoteDirTextField.getText();
     if ((requestedDir.length() == 2) && (requestedDir.endsWith(":")) )
     {
       // add a backslash to the drive requested to allow use of just drive letter & colon format
       String actualDir = requestedDir + "\\";
       RemoteDirTextField.setText(actualDir);
     }
	   cmd.append(RemoteDirTextField.getText());
     appendToHistory("Folder change to " + RemoteDirTextField.getText());
     RemoteFileTextField.setText("");
     setDetailsVisible(false);
     String cwdReply = getTheClient().performRequest(cmd);

	   if ((cwdReply.indexOf("PWD completed successfully") > 0)   && (cwdReply.indexOf(RemoteDirTextField.getText()) > 0))
	   {
	 	  String yyy =  handleServerResponse(cwdReply);
		  String listReply = getTheClient().performRequest(new StringBuffer("LIST"));
	    displayRemoteDirectory(listReply);
	   }
	   else
	   {
 		  String ggg = handleServerResponse(cwdReply);
      appendToHistory("Folder change failed.");
      getTheClient().performRequest(new StringBuffer("CD"));
 		  String pwdReply = getTheClient().performRequest(new StringBuffer("PWD"));
      String cleaned = handleServerResponse(pwdReply);
	    String strippedPwdReply = stripAwayNewlines(cleaned);
	    RemoteDirTextField.setText(strippedPwdReply);
	    String listReply = getTheClient().performRequest(new StringBuffer("LIST"));
	    displayRemoteDirectory(listReply);
	   }
 	return;
  }

  void jButtonShowHistory_actionPerformed(ActionEvent e) {
     if (aHistory == null)
          aHistory = new ShowHistory();
	   aHistory.show();
  }

  void jButtonDisconnect_actionPerformed(ActionEvent e) {
    		if ( (StatusLabel.getText().equals("Connected")) ||
			       (StatusLabel.getText().equals("Ready"))    ||
			       (StatusLabel.getText().equals("Transferring File")) )
	{
	  appendToHistory("Disconnecting...");
    setServerNameLabel("");
    setDetailsVisible(false);
	  RemoteFileTextField.setText("");
	  RemoteDirTextField.setText("");
    RemoteListModel.removeAllElements();
	   // disconnecting before rftpclient has had time to finish it's
	  // initialization causes the disconnect to hang.  Ensure that at
	  // least 20 seconds has passed since connection was performed.
	  java.util.Date disconnectTime = new java.util.Date();
	  long disconnectTimeInSeconds = disconnectTime.getTime();
	  long timepassed = disconnectTimeInSeconds - connectTimeInSeconds;
	  if ( timepassed < 20000)
	  {
		try	{java.lang.Thread.sleep(20000 - timepassed);}
		  catch (java.lang.InterruptedException eee) {}
	  } 
	  String result = getclient().performRequest(new StringBuffer("QUIT"));
	  String yyy = handleServerResponse(result);
	  setStatus("Not Connected");
	  client =null;
	}
	return;

  }

  void jMenuItemDisconnect_actionPerformed(ActionEvent e) {
    jButtonDisconnect_actionPerformed(e);
  }

 void setTransferType(StringBuffer b) {
  transferType.setLength(0);
  transferType.append(b);
 }
 public StringBuffer getTransferType() {
 return transferType;
 }
public String getLocalSelectedFile() {
   return jFileChooser1.getSelectedFile().getAbsolutePath();
}
public String getRemoteDirectoryName() { return RemoteDirTextField.getText();}

public String getRemoteSelectedFile() {

	   String currentDirectory = RemoteDirTextField.getText();
     StringBuffer selectedFile = new StringBuffer(currentDirectory);
     if (RemoteFileTextField.getText().equals("") )   ;   // nothing in filename just send the directory name
     else  {     //something in filename, add the sep char and filename
       String sepChar;
       if (currentDirectory.indexOf("\\") < 0) sepChar = "/"; else sepChar = "\\";
       // don't add the sepChar if the directory is a DOS drive which already has the sepchar
       if ((currentDirectory.length() == 3)  && currentDirectory.endsWith(":\\")) ;  //do nothing
	         else selectedFile.append(sepChar);
	     selectedFile.append(RemoteFileTextField.getText());
     }
     return selectedFile.toString();
}
public void transferFile(String local, String remote)    {
int per = 0;
try {
  transferCmd.setLength(0);
  remoteFileBeingTransferred.setLength(0);
  remoteFileBeingTransferred.append(remote);
  setStatus("Transferring File");
  localFileBeingTransferred = new File(local);
   if (transferType.toString().equals("Transfer from Remote to Local File"))
	{
	  transferCmd.append("RETR ").append(remote).append(" ").append(local);
 	}
	else if (transferType.toString().equals("Transfer from Local to Remote File"))
	{
		transferCmd.append("STOR ").append(local).append(" ").append(remote);
 	}
	else if (transferType.toString().equals("Resume Transfer from Local to Remote File"))
	{
		transferCmd.append("STOR ").append(local).append(" ").append(remote).append(" +");
 	}
	else  // transfer equals "Resume Transfer from Remote to Local File"
	{
		 transferCmd.append("RETR ").append(remote).append(" ").append(local).append(" +");
	}
	appendToHistory("Transferring File " + transferCmd.toString());
  String fileTransfer = getTheClient().performRequest(transferCmd);
	String ggg = handleServerResponse(fileTransfer);
  //Display the transfer progress every 1.5 seconds
  while (getTheClient().TransferInProgress())
    {  
       java.lang.Thread.sleep(1500);
       per =  getTheClient().getDataLink().getPercentTransferred();
       if (per != 0) ProgressLabel.setText("Transfer " + Integer.toString(per) + "% Complete");
    }
  appendToHistory("Transfer finished.");
  ProgressLabel.setText("");
  setStatus("Ready");
  }
  catch (NullPointerException ne) {System.out.println("null ptr exception from transferfile");}
  catch (RuntimeException re) {System.out.println("runtimeexception from transferfile");}
  catch (java.lang.InterruptedException eee) {System.out.println("Interruptedexception from transferfile");}
	return;
}

 public String getPercentTransferred() {
   long percentTransferred = 0;
   //System.out.println("%% Local Size: " + localFileBeingTransferred.length() + "trans size: " + getTheClient().getTransferSize());
  try {
   if (getStatus().equals("Transferring File"))
  {
     
      if (transferCmd.toString().startsWith("RETR"))
       {
         int denominator = getTheClient().getTransferSize();
         //System.out.println("transfersize: " + Integer.toString(denominator) + "   local: " +  Long.toString(localFileBeingTransferred.length()));
         if (denominator > 0)
          percentTransferred = localFileBeingTransferred.length() /  (long) denominator;
       }
      else    // transferCmd.startsWith STOR
      { StringBuffer cmdStat = new StringBuffer("STAT " + remoteFileBeingTransferred.toString());
	      String rfStat = getTheClient().performRequest(cmdStat);

	      // if the remotefile exists remotely, the sizePtr will be > 0 & show where the size is
        int remoteFileSize = 0;
        //System.out.println("Stat reply in getpercent: " + rfStat);
		    if (rfStat.startsWith("213",0))    //it is a file
				 {
	          int sizePtr = rfStat.indexOf("Size: ");
	          if (sizePtr > 0 )
	          {
		          String rfSizeStr = rfStat.substring(sizePtr + 6, rfStat.length() - 3).trim();
	 	          remoteFileSize = new Integer(rfSizeStr).intValue();
	          }
	       }
         // it is possible to mistakenly intercept the response to the file transfer
         // handle it - and you are done
         else if (rfStat.startsWith("226 ***File Transferred. Closed data Connection."))
         {
             String notInterested = handleServerResponse(rfStat);
             percentTransferred = 100;
         }
          int denominator2 = getTheClient().getTransferSize();
          if (denominator2 > 0) percentTransferred = remoteFileSize / denominator2;
       }
       String retVal = Long.toString(percentTransferred);
       //System.out.println("Percent transferred: " + retVal);
       return  retVal;
   }  } catch (NullPointerException eieieo) {System.out.println("Null Pointer exception in getpercenttransferred");}
        catch (RuntimeException ioe) {System.out.println("runtime exception in getpercenttransferred");}
    return "Transfer Complete";   //not transferring a file
}

  void jButtonResRet_actionPerformed(ActionEvent e) {
     setStatus("Transferring File");
     setTransferType(new StringBuffer("Resume Transfer from Remote to Local File"));
	   aTransferDialog = new TransferFileD();
	   RunTransfer rt = new RunTransfer(aTransferDialog);
     Thread newTransferThread = new Thread(rt);
	   newTransferThread.start();
	   return;
  }

  void jButton7_actionPerformed(ActionEvent e) {
     setStatus("Transferring File");
     setTransferType(new StringBuffer("Transfer from Local to Remote File"));
	   aTransferDialog = new TransferFileD();
	   RunTransfer rt = new RunTransfer(aTransferDialog);
     Thread newTransferThread = new Thread(rt);
	   newTransferThread.start();
	   return;
  }

  void jButton8_actionPerformed(ActionEvent e) {
     setStatus("Transferring File");
     setTransferType(new StringBuffer("Resume Transfer from Local to Remote File"));
	   aTransferDialog = new TransferFileD();
	   RunTransfer rt = new RunTransfer(aTransferDialog);
     Thread newTransferThread = new Thread(rt);
	   newTransferThread.start();
	   return;
  }
  public void setServerNameLabel(String s){
     jLabelServerName.setText(s);
  }

  void jMenuItemConnect_actionPerformed(ActionEvent e) {
    jButtonConnect_actionPerformed(e)  ;
  }

  void RemoteNewDirButton_actionPerformed(ActionEvent e) {
    aNewDirDialog = new NewDirDialog(new JFrame(), "Make new remote directory",false);
	   aNewDirDialog.show();
  }

  void jButton6_actionPerformed(ActionEvent e) {
      appendToHistory("Aborting transfer");
      String abortReply = getTheClient().performRequest(new StringBuffer("ABOR"));
	    String ggg = handleServerResponse(abortReply);
  }

  void refreshButton_actionPerformed(ActionEvent e) {
     RemoteFileTextField.setText("");
     setDetailsVisible(false);
     String listReply = getTheClient().performRequest(new StringBuffer("LIST"));
	   displayRemoteDirectory(listReply);
  }

  void jButton3_actionPerformed(ActionEvent e) {
   aRftpHelp = new RftpHelp();
   aRftpHelp.show();
  }

}  //end FrameFM

class RunTransfer implements Runnable
{

private TransferFileD transferd;
/* This thread runs the transfer independently to allow control switching so
the transfer may be aborted.  */

public RunTransfer(TransferFileD td)

{
   transferd = td;
}
public void run()
{
   transferd.show();
}
}  //end class RunTransfer
