
//Title:       RFTP TransferFileD
///Version:    1.0
//Copyright:   1999
//Author:      Mary Grzywa
//Company:     Illinois State University Graduate Project
//Description: Resumable File Transfer Protocol

package rftp;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class TransferFileD extends JFrame {
  JPanel jPanel1 = new JPanel();
  JLabel jLabellocal = new JLabel();
  JLabel jLabelRemote = new JLabel();
  JLabel jLabelTransType = new JLabel();
  JTextField LocalFile = new JTextField();
  JTextField RemoteFile = new JTextField();
  JButton TransferButton = new JButton();
  JButton CancelButton = new JButton();
  FrameFM myFMParent  = null;
  JButton ProgBar5 = new JButton();
  JButton ProgBar0 = new JButton();
  public TransferFileD() {
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    jLabellocal.setText("Local: ");
    jLabellocal.setBounds(new Rectangle(46, 28, 38, 17));
    jPanel1.setLayout(null);
    jLabelRemote.setText("Remote: ");
    jLabelRemote.setBounds(new Rectangle(31, 95, 52, 17));
    jLabelTransType.setBounds(new Rectangle(40, 65, 319, 17));
    LocalFile.setBounds(new Rectangle(87, 27, 270, 21));
    RemoteFile.setBounds(new Rectangle(86, 93, 267, 21));
    TransferButton.setText("Transfer");
    TransferButton.setBounds(new Rectangle(51, 205, 85, 27));
    this.setSize(new Dimension(420, 275));
    TransferButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        TransferButton_actionPerformed(e);
      }
    });
    this.setTitle("Transfer File");
    this.addWindowListener(new java.awt.event.WindowAdapter() {

      public void windowOpened(WindowEvent e) {
        this_windowOpened(e);
      }
    });
    CancelButton.setText("Cancel");
    CancelButton.setBounds(new Rectangle(222, 204, 86, 27));
    CancelButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        CancelButton_actionPerformed(e);
      }
    });
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(TransferButton, null);
    jPanel1.add(CancelButton, null);
    jPanel1.add(jLabellocal, null);
    jPanel1.add(LocalFile, null);
    jPanel1.add(jLabelTransType, null);
    jPanel1.add(jLabelRemote, null);
    jPanel1.add(RemoteFile, null);
   }

  void CancelButton_actionPerformed(ActionEvent e) {
    getmyParent().setStatus("Ready");
    this.dispose();
  }
    public FrameFM getmyParent() {
  if (myFMParent == null) myFMParent = FrameFM.getTransferDialogParent(this);
  return myFMParent;
  }
  void this_windowOpened(WindowEvent e) {

    jLabelTransType.setText(getmyParent().getTransferType().toString());
    try {
    LocalFile.setText(getmyParent().getLocalSelectedFile());
    } catch (NullPointerException eee) {}
    RemoteFile.setText(getmyParent().getRemoteSelectedFile());
  }

  void TransferButton_actionPerformed(ActionEvent e) {
      TransferThread newTransfer = new TransferThread(getmyParent(),LocalFile.getText(),RemoteFile.getText());
      Thread newTransferThread = new Thread(newTransfer);
      newTransferThread.start();
      this.dispose();
  }
}

class TransferThread implements Runnable
{
private FrameFM par;
private String local;
private String remote;
/* This thread exists to run the transfer independently.  */

public TransferThread( FrameFM p,  String loc, String rem)
{
   par = p;
   local = loc;
   remote = rem;
}
public void run()
{
  try {
    par.transferFile(local,remote);
    }
    catch (java.lang.NullPointerException ewioe) {}
}
}  //end class TransferThread
